org.encog.neural.freeform.training

## Class FreeformBackPropagation

- java.lang.Object
- - org.encog.ml.train.BasicTraining
  - - org.encog.neural.freeform.training.FreeformPropagationTraining
    - - org.encog.neural.freeform.training.FreeformBackPropagation

- All Implemented Interfaces:
    Serializable, MLTrain

      public class FreeformBackPropagation
      extends FreeformPropagationTraining
      implements Serializable

  Perform backpropagation for a freeform neural network.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.encog.neural.freeform.training.FreeformPropagationTraining

      `FLAT_SPOT_CONST`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FreeformBackPropagation(FreeformNetwork theNetwork, MLDataSet theTraining, double theLearningRate, double theMomentum)` Construct a back propagation trainer.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `learnConnection(FreeformConnection connection)` Learn for a single connection.
    `TrainingContinuation` | `pause()` Pause the training to continue later.
    `void` | `resume(TrainingContinuation state)` Resume training.

    - ### Methods inherited from class org.encog.neural.freeform.training.FreeformPropagationTraining

      `canContinue, finishTraining, getBatchSize, getError, getImplementationType, getIteration, getMethod, getTraining, isFixFlatSopt, iteration, iteration, learn, processBatches, processPureBatch, setBatchSize, setError, setFixFlatSopt, setIteration`

    - ### Methods inherited from class org.encog.ml.train.BasicTraining

      `addStrategy, getStrategies, isTrainingDone, postIteration, preIteration, setTraining`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FreeformBackPropagation

          public FreeformBackPropagation(FreeformNetwork theNetwork,
                                 MLDataSet theTraining,
                                 double theLearningRate,
                                 double theMomentum)

      Construct a back propagation trainer.
      Parameters:
        `theNetwork` - The network to train.
        `theTraining` - The training data to use. The coefficient for how much of the gradient is applied to each weight.
        `theLearningRate` - The learning rate. The coefficient for how much of the previous delta is applied to each weight. In theory, prevents local minima stall.
        `theMomentum` - The momentum.

  - ### Method Detail

    - #### learnConnection

          protected void learnConnection(FreeformConnection connection)

      Learn for a single connection.
      Specified by:
        `learnConnection` in class `FreeformPropagationTraining`
      Parameters:
        `connection` - The connection to learn from.

    - #### pause

          public TrainingContinuation pause()

      Pause the training to continue later.
      Specified by:
        `pause` in interface `MLTrain`
      Returns:
        A training continuation object.

    - #### resume

          public void resume(TrainingContinuation state)

      Resume training.
      Specified by:
        `resume` in interface `MLTrain`
      Parameters:
        `state` - The training continuation object to use to continue.

Copyright © 2014. All Rights Reserved.